mesa: Changes to 'ubuntu'
debian/changelog | 8 +++++-
debian/libgl1-mesa-swx11.postinst | 26 ++++++++++++++++++++
debian/libgl1-mesa-swx11.prerm | 23 ++++++++++++++++++
debian/patches/100_no_abi_tag.patch | 46 ++++++++++++++++++++++++++++++++++++
debian/patches/series | 1
debian/rules | 5 +++
6 files changed, 108 insertions(+), 1 deletion(-)
New commits:
commit 976c5dc0e775fa1a2b37e51215c40b7531dff66f
Author: Robert Hooker <sarvatt@ubuntu.com>
Date: Fri Feb 12 17:19:43 2010 -0500
Install alternatives for libgl1-mesa-swx11 as well.
diff --git a/debian/libgl1-mesa-swx11.postinst b/debian/libgl1-mesa-swx11.postinst
new file mode 100644
index 0000000..733f959
--- /dev/null
+++ b/debian/libgl1-mesa-swx11.postinst
@@ -0,0 +1,26 @@
+#!/bin/sh
+
+set -e
+
+THIS_PACKAGE=libgl1-mesa-swx11
+THIS_SCRIPT=postinst
+
+case "$1" in
+ configure)
+ # Use alternatives to make it easier to switch between Mesa and 3rd party modules
+ update-alternatives --force \
+ --install /etc/ld.so.conf.d/GL.conf gl_conf /usr/lib/mesa/ld.so.conf 500 \
+ --slave /usr/lib/xorg/extra-modules xorg_extra_modules /usr/lib/xorg/x11-extra-modules
+
+ # ldconfig needs to be run immediately as we're changing /etc/ld.so.conf.d/ with
+ # alternatives.
+ LDCONFIG_NOTRIGGER=y ldconfig
+
+esac
+
+#DEBHELPER#
+
+exit 0
+
+# vim:set ai et sw=2 ts=2 tw=80:
+
diff --git a/debian/libgl1-mesa-swx11.prerm b/debian/libgl1-mesa-swx11.prerm
new file mode 100644
index 0000000..3683002
--- /dev/null
+++ b/debian/libgl1-mesa-swx11.prerm
@@ -0,0 +1,23 @@
+#!/bin/sh
+
+set -e
+
+THIS_PACKAGE=libgl1-mesa-swx11
+THIS_SCRIPT=prerm
+
+case "$1" in
+ remove)
+ # Use alternatives to make it easier to switch between Mesa and 3rd party modules
+ update-alternatives --remove gl_conf /usr/lib/GL/ld.so.conf
+
+ # explicit ldconfig due to alternatives
+ ldconfig
+
+esac
+
+#DEBHELPER#
+
+exit 0
+
+# vim:set ai et sw=2 ts=2 tw=80:
+
diff --git a/debian/rules b/debian/rules
index 15b26f2..f180b67 100755
--- a/debian/rules
+++ b/debian/rules
@@ -232,15 +232,20 @@ binary-arch: install
# Create an ld.so.conf which says where to find libGL from Mesa
echo "/usr/lib/mesa" \
> $(CURDIR)/debian/libgl1-mesa-glx/usr/lib/mesa/ld.so.conf
+ echo "/usr/lib/mesa" \
+ > $(CURDIR)/debian/libgl1-mesa-swx11/usr/lib/mesa/ld.so.conf
ifeq ($(DEB_BUILD_ARCH),amd64)
# Add the path to 32bit libGL from Mesa (on 64 bit)
echo "/usr/lib32/mesa" \
>> $(CURDIR)/debian/libgl1-mesa-glx/usr/lib/mesa/ld.so.conf
+ echo "/usr/lib32/mesa" \
+ >> $(CURDIR)/debian/libgl1-mesa-swx11/usr/lib/mesa/ld.so.conf
endif
# Empty directory for the alternative
mkdir -p $(CURDIR)/debian/libgl1-mesa-glx/usr/lib/xorg/x11-extra-modules
+ mkdir -p $(CURDIR)/debian/libgl1-mesa-swx11/usr/lib/xorg/x11-extra-modules
dh_installman -s
dh_lintian -s
commit 4080888c0c140b8abc120d1f1d27bd94e0462c2f
Author: Robert Hooker <sarvatt@ubuntu.com>
Date: Fri Feb 12 16:59:52 2010 -0500
Add 100_no_abi_tag.patch
Removes the ABI tag in /usr/lib/libGL.so.1 which prevented ldconfig
from using a libGL from another directory at a higher priority than
the one in /usr/lib with alternatives.
diff --git a/debian/changelog b/debian/changelog
index 53ad124..35c3390 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -1,8 +1,14 @@
mesa (7.7-3ubuntu1) UNRELEASED; urgency=low
+ [ Timo Aaltonen ]
* Merge from Debian experimental.
- -- Timo Aaltonen <tjaalton@ubuntu.com> Fri, 05 Feb 2010 15:58:07 +0200
+ [ Robert Hooker ]
+ * Add 100_no_abi_tag.patch: Removes the ABI tag in /usr/lib/libGL.so.1
+ which prevented ldconfig from using a libGL from another directory
+ at a higher priority than the one in /usr/lib.
+
+ -- Robert Hooker <sarvatt@ubuntu.com> Fri, 12 Feb 2010 16:57:30 -0500
mesa (7.7-3) experimental; urgency=low
diff --git a/debian/patches/100_no_abi_tag.patch b/debian/patches/100_no_abi_tag.patch
new file mode 100644
index 0000000..74d80d0
--- /dev/null
+++ b/debian/patches/100_no_abi_tag.patch
@@ -0,0 +1,46 @@
+diff --git a/src/mesa/x86-64/glapi_x86-64.S b/src/mesa/x86-64/glapi_x86-64.S
+index 8edb69b..4f8ec21 100644
+--- a/src/mesa/x86-64/glapi_x86-64.S
++++ b/src/mesa/x86-64/glapi_x86-64.S
+@@ -30692,18 +30692,6 @@ GL_PREFIX(_dispatch_stub_802):
+ .globl GL_PREFIX(FramebufferTextureLayer) ; .set GL_PREFIX(FramebufferTextureLayer), GL_PREFIX(FramebufferTextureLayerEXT)
+ .globl GL_PREFIX(ProvokingVertex) ; .set GL_PREFIX(ProvokingVertex), GL_PREFIX(ProvokingVertexEXT)
+
+-#if defined(GLX_USE_TLS) && defined(__linux__)
+- .section ".note.ABI-tag", "a"
+- .p2align 2
+- .long 1f - 0f /* name length */
+- .long 3f - 2f /* data length */
+- .long 1 /* note length */
+-0: .asciz "GNU" /* vendor name */
+-1: .p2align 2
+-2: .long 0 /* note data: the ABI tag */
+- .long 2,4,20 /* Minimum kernel version w/TLS */
+-3: .p2align 2 /* pad out section */
+-#endif /* GLX_USE_TLS */
+
+ #if defined (__ELF__) && defined (__linux__)
+ .section .note.GNU-stack,"",%progbits
+diff --git a/src/mesa/x86/glapi_x86.S b/src/mesa/x86/glapi_x86.S
+index 8030fdf..3d97954 100644
+--- a/src/mesa/x86/glapi_x86.S
++++ b/src/mesa/x86/glapi_x86.S
+@@ -1332,18 +1332,6 @@ GLNAME(gl_dispatch_functions_start):
+ ALIGNTEXT16
+ GLNAME(gl_dispatch_functions_end):
+
+-#if defined(GLX_USE_TLS) && defined(__linux__)
+- .section ".note.ABI-tag", "a"
+- .p2align 2
+- .long 1f - 0f /* name length */
+- .long 3f - 2f /* data length */
+- .long 1 /* note length */
+-0: .asciz "GNU" /* vendor name */
+-1: .p2align 2
+-2: .long 0 /* note data: the ABI tag */
+- .long 2,4,20 /* Minimum kernel version w/TLS */
+-3: .p2align 2 /* pad out section */
+-#endif /* GLX_USE_TLS */
+
+ #if defined (__ELF__) && defined (__linux__)
+ .section .note.GNU-stack,"",%progbits
diff --git a/debian/patches/series b/debian/patches/series
index 205e50c..536e86e 100644
--- a/debian/patches/series
+++ b/debian/patches/series
@@ -3,6 +3,7 @@
04_osmesa_version.diff
05_hurd-ftbfs.diff
06_kfreebsd-ftbfs.diff
+100_no_abi_tag.patch
101_ubuntu_hidden_glname.patch
102_dont_vblank.diff
107_glxgears_is_not_a_benchmark.patch
Reply to: